# DCL

## Overview

DCL은 GNU/Linux를 비롯한 UNIX 운영체제와 Microsoft Windows 운영체제에서 소스프로그램 수준의 이식성있는 C++ 클래스 라이브러리 입니다.

DCLCore는 DCL 프로젝트의 중심을 이루고 있는 라이브러리 패키지 입니다. 이 패키지는 String을 비롯한 Array, List, HashMap등의 콜렉션 클래스들과 날짜 및 시간을 위한 클래스, Regex 클래스, 스트림 클래스, 데이터베이스 서버 연결을 위한 클래스, File, Socket, SerialPort, Thread, Mutex와 같은 시스템 객체에 관한 클래스를 포함하고 있습니다.

DCLCore의 가장 중요한 부분은 라이브러리 차원에서 어플리케이션의 실행시간 디버깅을 위한 환경을 제공한다는 것 입니다. 이 환경은 프로그램 작성에 있어서 ASSERT, TRACE를 사용하도록 하는 방법을 제공 할 뿐만 아니라 동적 메모리 할당과 해제에 관하여 라이브러리 차원의 추적이 가능하도록 하고 있습니다. 만약 어플리케이션이 다중 스레드 어플리케이션일 경우 스레드별 추적도 가능 합니다.

DCL에는 [Firebird](https://www.firebirdsql.org/), [InterBase](https://www.embarcadero.com/products/interbase), [Informix](https://www.ibm.com/kr-ko/products/informix), [MariaDB](https://mariadb.com/docs/server/connect/programming-languages/c/), [MySQL](https://dev.mysql.com/downloads/c-api/), [Oracle Database](https://www.oracle.com/kr/database/technologies/appdev/oci.html) 네이티브 C 프로그래밍 언어 API를 사용한 드라이버 구현을 포함합니다.

DCL HTTP Server Extension은  Apache1, Apache2, IIS 웹 서버에서 네이티브 DSO(Dynamic Shared Object, DLL, so) 서블릿을 개발하고 실행 할 수 있는 환경을 제공합니다.

## License

Copyright &copy; 2002-2025 [Daejung Kim](http://www.gowoonsoft.com)
